]> git.pld-linux.org Git - packages/nfs-utils.git/blame - nfsfs.init
- typo
[packages/nfs-utils.git] / nfsfs.init
CommitLineData
9fddaaa8
JR
1#!/bin/sh
2#
ff100ffc 3# nfsfs Mount NFS filesystems.
9fddaaa8 4#
891a86c9 5# chkconfig: 345 16 80
ff100ffc 6# description: Mounts and unmounts all Network File System (NFS) \
7# mount points.
9fddaaa8
JR
8
9# Source networking configuration.
10if [ ! -f /etc/sysconfig/network ]; then
ff100ffc 11 exit 0
9fddaaa8
JR
12fi
13
14# Source function library.
15. /etc/rc.d/init.d/functions
16
ff100ffc 17# Get network config
9fddaaa8
JR
18. /etc/sysconfig/network
19
2da61068 20# Get service config
eed927a9 21[ -f /etc/sysconfig/nfsfs ] && . /etc/sysconfig/nfsfs
af75af5c 22[ -f /etc/sysconfig/nfslock ] && . /etc/sysconfig/nfslock
2da61068 23
9fddaaa8 24# Check that networking is up.
ff100ffc 25if is_yes "${NETWORKING}"; then
b69cfb4d 26 if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
ff100ffc 27 msg_network_down nfsfs
28 exit 1
29 fi
30else
31 exit 0
9fddaaa8
JR
32fi
33
fcdc7f4e
JR
34if [ "$1" != "stop" ]; then
35 check_portmapper || { nls "Error: portmap isn't running" && exit 0; }
af75af5c
JR
36fi
37
74415e33
JR
38if [ -z "$NFSUMOUNT_IGNORE" ]; then
39 NFSUMOUNT_IGNORE="/ /usr"
40fi
41
ad615b8a 42start() {
c70958a8 43 if [ ! -f /var/lock/subsys/nfsfs ]; then
af75af5c
JR
44 # Set the ports lockd should listen on
45 if [ -n "$LOCKD_TCPPORT" ]; then
46 /sbin/sysctl -w fs.nfs.nlm_tcpport=$LOCKD_TCPPORT >/dev/null 2>&1
47 fi
48 if [ -n "$LOCKD_UDPPORT" ]; then
49 /sbin/sysctl -w fs.nfs.nlm_udpport=$LOCKD_UDPPORT >/dev/null 2>&1
28c13cdf 50 fi
af75af5c
JR
51
52 # Special case /usr first
1fbf8b87 53 if ! awk '{ if ($2 == "/usr" && $3 ~ /^nfs(4$|$)/ && $4 !~ /noauto/) exit 1}' /etc/fstab ; then
af75af5c
JR
54 run_cmd "Mounting /usr filesystem" mount /usr
55 # In case of /usr over NFS idmapd, gssd and lockd may not start
56 # check if they're running and try to start them if not
57 /sbin/service idmapd status >/dev/null || /sbin/service idmapd start
58 /sbin/service gssd status >/dev/null || /sbin/service gssd start
59 /sbin/service nfslock status >/dev/null || /sbin/service nfslock start
60 fi
61 run_cmd "Mounting NFS filesystems" mount -a -t nfs,nfs4
07a92029 62 touch /var/lock/subsys/nfsfs
af75af5c 63
c70958a8
AM
64 else
65 msg_already_running "NFSFS"
66 fi
ad615b8a
ER
67}
68
69stop() {
5da51246 70 if [ -f /proc/mounts ]; then
eafe4dfc 71 fsfile="/proc/mounts"
72 else
73 fsfile="/etc/mtab"
74 fi
75
07a92029
JR
76 show "Unmounting NFS filesystems"
77 busy
78 retry=3
74415e33
JR
79 remaining=$(awk -v ig="^($NFSUMOUNT_IGNORE)$" 'BEGIN { gsub(/[\t ]+/, "|", ig); } \
80 $3 ~ /^nfs(4$|$)/ && $2 !~ ig {print $2}' $fsfile)
07a92029 81 while [ -n "$remaining" -a $retry -gt 0 ]; do
74415e33 82 fuser -msk -TERM `awk -v ig="^($NFSUMOUNT_IGNORE)$" 'BEGIN { gsub(/[\t ]+/, "|", ig); } \
ab3b4a50 83 $3 ~ /^nfs(4$|$)/ && $2 !~ ig {print $2}' $fsfile`
07a92029 84 sleep 2
74415e33 85 fuser -msk -KILL `awk -v ig="^($NFSUMOUNT_IGNORE)$" 'BEGIN { gsub(/[\t ]+/, "|", ig); } \
ab3b4a50 86 $3 ~ /^nfs(4$|$)/ && $2 !~ ig {print $2}' $fsfile`
894b672d
JR
87 # Sort filesystems to unmount in reverse order
88 rem=""
ab3b4a50 89 for r in $(awk -v ig="^($NFSUMOUNT_IGNORE)$" 'BEGIN { gsub(/[\t ]+/, "|", ig); } \
74415e33 90 $3 ~ /^nfs(4$|$)/ && $2 !~ ig {print $2}' $fsfile) ; do
894b672d
JR
91 rem="$r $rem"
92 done
93 for fs in $rem ; do
94 umount $fs
95 done
74415e33
JR
96 remaining=$(awk -v ig="^($NFSUMOUNT_IGNORE)$" 'BEGIN { gsub(/[\t ]+/, "|", ig); } \
97 $3 ~ /^nfs(4$|$)/ && $2 !~ ig {print $2}' $fsfile)
07a92029
JR
98 retry=$(($retry-1))
99 done
100 ok
9fddaaa8 101 rm -f /var/lock/subsys/nfsfs
ad615b8a
ER
102}
103
104# See how we were called.
105case "$1" in
106 start)
107 start
108 ;;
109 stop)
110 stop
9fddaaa8
JR
111 ;;
112 status)
5da51246 113 if [ -f /proc/mounts ]; then
9fddaaa8 114 echo "Configured NFS mountpoints:"
0c170055 115 grep -v '^#' /etc/fstab | \
af75af5c 116 awk '{ if ($3 ~ /^nfs(4$|$)/ && $4 !~ /noauto/) print $2}'
9fddaaa8 117 echo "Active NFS mountpoints:"
0c170055 118 grep -v '^#' /proc/mounts | \
af75af5c 119 awk '{ if ($3 ~ /^nfs(4$|$)/ && $4 !~ /noauto/) print $2}'
9fddaaa8
JR
120 else
121 echo "/proc filesystem unavailable"
122 fi
123 ;;
124 restart)
ad615b8a
ER
125 stop
126 start
9fddaaa8 127 ;;
5246d326 128 reload|force-reload)
af75af5c 129 mount -a -t nfs,nfs4
9fddaaa8
JR
130 ;;
131 *)
5246d326 132 msg_usage "$0 {start|stop|restart|reload|force-reload|status}"
133 exit 3
9fddaaa8
JR
134esac
135
136exit 0
This page took 0.056757 seconds and 4 git commands to generate.